var eProgress = {

	value : 0,
	minPercent : 1,
	timerHandler : false,
	timerInc : 0,
	wrapper : _.make('.eProgress.eProgressHide', { last : document.body }),
	
	start : function(at) {
		this.setPercent(at ? at : this.minPercent);
	},
	
	setPercent : function(at, noShow) {
		if (!noShow) _.Class.swap(this.wrapper, 'eProgressHide', 'eProgressShow');
		this.value = at;
		if (this.value < 0) this.value = 0;
		if (this.value >= 100) this.done();
			else this.bar.style.width = this.value + '%';
	},
	
	setFractional : function(at) {
		this.setPercent(at * 100);
	},
	
	addPercent : function(amount) {
		this.setPercent(this.value + amount);
	},
	
	addFractional : function(amount) {
		this.setPercent(this.value + amount * 100);
	},
	
	auto : function(amount, interval) {
		_.Class.swap(this.wrapper, 'eProgressHide', 'eProgressShow');
		_.Class.add(this.wrapper, 'eProgressAuto');
		this.timerInc = amount;
		if (!this.timerHandler) this.timerHandler = setInterval(function() {
			eProgress.addPercent(eProgress.timerInc);
		}, interval ? interval : 290);
	},
	
	autoStop : function() {
		_.Class.remove(this.wrapper, 'eProgressAuto');
		if (this.timerHandler) {
			clearInterval(this.timerHandler);
			this.timerHandler = false;
		}
	},
	
	done : function() {
		this.value = 100;
		this.bar.style.width = '100%';
		this.autoStop();
		setTimeout(function() {
			_.Class.swap(eProgress.wrapper, 'eProgressShow', 'eProgressHide');
			_.Class.remove(this.wrapper, 'eProgressAuto');
			setTimeout(function() { eProgress.setPercent(0, true); }, 500);
		}, 333);
	}
};

// you can't reference itself when using instancing
eProgress.bar = _.make('.eProgressBar', { last : eProgress.wrapper});

// generated content doesn't frame-animate properly :(
_.make('.eProgressSpinner', { last : eProgress.wrapper});

_.Load.style('eProgress.screen.css', 'screen,projection,tv');
