/*
	eSmooth.js -- smooth scroll to hash link using elementals.js
	Jason M. Knight, 5 March 2017
*/

(function(w, d) {

	"use strict";
	if (
		(typeof _eSmoothForce != 'undefined' && _eSmoothForce) ||
		(history && history.pushState)
	) {
	
		if (typeof _eSmoothNoHistory == 'undefined') var _eSmoothNoHistory = false;
		if (typeof _eSmoothAccelerate == 'undefined') var _eSmoothAccelerate = 2;
		if (typeof _eSmoothMaxRate == 'undefined') var _eSmoothMaxRate = 128;
		
		var 
			yCur, yTo, yV,
			active = 0,
			a = d.getElementsByTagName('a'),
			h = w.location.href,
			o = h.indexOf('#'),
			
			stop = function() {
				active = false;
				yV = 0;
				w.scrollTo(0, yCur = yTo);
			},
		
			scroll = function() {
				if (yCur > yTo) {
					if (yV > -_eSmoothMaxRate) yV -= _eSmoothAccelerate;
					if ((yCur += yV) <= yTo) return stop();
				} else {
					if (yV < _eSmoothMaxRate) yV += _eSmoothAccelerate;
					if ((yCur += yV) >= yTo) return stop();
				}
				w.scrollTo(0, yCur);
				w.requestAnimationFrame(scroll);
			},
			
			click = function(e) {
				if (
					history && history.pushState &&
					!_eSmoothNoHistory &&
					!_.dataGet(e.currentTarget, 'eSmoothNoHistory')
				) history.pushState({}, '', e.currentTarget.href);
				var t = e.currentTarget.href.strFrom('#');
				if (t && (t = d.getElementById(t))) {
					yCur = _.Metrics.Scroll.y();
					yTo = Math.min(_.Metrics.absoluteY(t), _.Metrics.Scroll.maxY());
					if (!active) {
						yV = 0;
						active = true;
						w.requestAnimationFrame(scroll);
					}
				}
			};
			
		if (o >= 0) h = h.substr(0, o);
		h += '#';
		o = h.length;
		for (var i = 0, j; j = a[i]; i++) if (
			j.href.substr(0, o) == h &&
			!_.dataGet(j, 'eSmoothNoScroll')
		) _.Event.add(j, 'click', click, _.Event.PREVENT_PROPAGATION);
			
	}
})(window, document);